Index: branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/LIM_SRC_3/limthd_dh.F90
===================================================================
--- branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/LIM_SRC_3/limthd_dh.F90	(revision 3614)
+++ branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/LIM_SRC_3/limthd_dh.F90	(revision 3625)
@@ -7,5 +7,6 @@
    !!                 ! 2005-06 (M. Vancoppenolle) 3D version 
    !!            3.2  ! 2009-07 (M. Vancoppenolle, Y. Aksenov, G. Madec) bug correction in rdmsnif & rdmicif
-   !!            4.0  ! 2011-02 (G. Madec) dynamical allocation
+   !!            3.4  ! 2011-02 (G. Madec) dynamical allocation
+   !!            3.5  ! 2012-10 (G. Madec & co) salt flux + bug fixes 
    !!----------------------------------------------------------------------
 #if defined key_lim3
@@ -13,15 +14,16 @@
    !!   'key_lim3'                                      LIM3 sea-ice model
    !!----------------------------------------------------------------------
-   !!   lim_thd_dh  : vertical accr./abl. and lateral ablation of sea ice
-   !!----------------------------------------------------------------------
-   USE par_oce          ! ocean parameters
-   USE phycst           ! physical constants (OCE directory) 
-   USE sbc_oce          ! Surface boundary condition: ocean fields
-   USE ice              ! LIM variables
-   USE par_ice          ! LIM parameters
-   USE thd_ice          ! LIM thermodynamics
-   USE in_out_manager   ! I/O manager
-   USE lib_mpp          ! MPP library
-   USE wrk_nemo         ! work arrays
+   !!   lim_thd_dh    : vertical accr./abl. and lateral ablation of sea ice
+   !!----------------------------------------------------------------------
+   USE par_oce        ! ocean parameters
+   USE phycst         ! physical constants (OCE directory) 
+   USE sbc_oce        ! Surface boundary condition: ocean fields
+   USE ice            ! LIM variables
+   USE par_ice        ! LIM parameters
+   USE thd_ice        ! LIM thermodynamics
+   USE in_out_manager ! I/O manager
+   USE lib_mpp        ! MPP library
+   USE wrk_nemo       ! work arrays
+   USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
 
    IMPLICIT NONE
@@ -37,5 +39,5 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2010)
+   !! NEMO/LIM3 3.4 , UCL - NEMO Consortium (2011)
    !! $Id$
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -71,5 +73,5 @@
       !! 
       INTEGER  ::   ji , jk        ! dummy loop indices
-      INTEGER  ::   zji, zjj       ! 2D corresponding indices to ji
+      INTEGER  ::   ii, ij       ! 2D corresponding indices to ji
       INTEGER  ::   isnow          ! switch for presence (1) or absence (0) of snow
       INTEGER  ::   isnowic        ! snow ice formation not
@@ -102,8 +104,8 @@
       REAL(wp), POINTER, DIMENSION(:) ::   zfmass_i    ! 
 
-      REAL(wp), POINTER, DIMENSION(:) ::   zdh_s_mel     ! snow melt 
-      REAL(wp), POINTER, DIMENSION(:) ::   zdh_s_pre     ! snow precipitation 
-      REAL(wp), POINTER, DIMENSION(:) ::   zdh_s_sub     ! snow sublimation
-      REAL(wp), POINTER, DIMENSION(:) ::   zfsalt_melt   ! salt flux due to ice melt
+      REAL(wp), POINTER, DIMENSION(:) ::   zdh_s_mel   ! snow melt 
+      REAL(wp), POINTER, DIMENSION(:) ::   zdh_s_pre   ! snow precipitation 
+      REAL(wp), POINTER, DIMENSION(:) ::   zdh_s_sub   ! snow sublimation
+      REAL(wp), POINTER, DIMENSION(:) ::   zsfx_melt   ! salt flux due to ice melt
 
       REAL(wp), POINTER, DIMENSION(:,:) ::   zdeltah
@@ -126,12 +128,12 @@
 
       CALL wrk_alloc( jpij, zh_i, zh_s, ztfs, zhsold, zqprec, zqfont_su, zqfont_bo, z_f_surf, zhgnew, zfmass_i )
-      CALL wrk_alloc( jpij, zdh_s_mel, zdh_s_pre, zdh_s_sub, zfsalt_melt, zfdt_init, zfdt_final, zqt_i, zqt_s, zqt_dummy )
+      CALL wrk_alloc( jpij, zdh_s_mel, zdh_s_pre, zdh_s_sub, zsfx_melt, zfdt_init, zfdt_final, zqt_i, zqt_s, zqt_dummy )
       CALL wrk_alloc( jpij, zinnermelt, zfbase, zdq_i )
       CALL wrk_alloc( jpij, jkmax, zdeltah, zqt_i_lay )
 
-      zfsalt_melt(:)  = 0._wp
-      ftotal_fin(:)   = 0._wp
-      zfdt_init(:)    = 0._wp
-      zfdt_final(:)   = 0._wp
+      zsfx_melt (:) = 0._wp
+      ftotal_fin(:) = 0._wp
+      zfdt_init (:) = 0._wp
+      zfdt_final(:) = 0._wp
 
       DO ji = kideb, kiut
@@ -145,8 +147,8 @@
       !
       DO ji = kideb, kiut
-         isnow         = INT( 1.0 - MAX ( 0.0 , SIGN ( 1.0 , - ht_s_b(ji) ) ) )
-         ztfs(ji)      = isnow * rtt + ( 1.0 - isnow ) * rtt
-         z_f_surf(ji)  = qnsr_ice_1d(ji) + ( 1.0 - i0(ji) ) * qsr_ice_1d(ji) - fc_su(ji)
-         z_f_surf(ji)  = MAX( zzero , z_f_surf(ji) ) * MAX( zzero , SIGN( zone , t_su_b(ji) - ztfs(ji) ) )
+         isnow         = INT(  1.0 - MAX(  0.0 , SIGN( 1.0 , - ht_s_b(ji) )  )  )
+         ztfs     (ji) = isnow * rtt + ( 1.0 - isnow ) * rtt
+         z_f_surf (ji) = qnsr_ice_1d(ji) + ( 1.0 - i0(ji) ) * qsr_ice_1d(ji) - fc_su(ji)
+         z_f_surf (ji) = MAX(  zzero , z_f_surf(ji)  ) * MAX(  zzero , SIGN( zone , t_su_b(ji) - ztfs(ji) )  )
          zfdt_init(ji) = ( z_f_surf(ji) + MAX( fbif_1d(ji) + qlbbq_1d(ji) + fc_bo_i(ji),0.0 ) ) * rdt_ice
       END DO ! ji
@@ -240,10 +242,10 @@
          zhsnew         =  ht_s_b(ji) + dh_s_tot(ji)
          ! If snow is still present zhn = 1, else zhn = 0
-         zhn            =  1.0 - MAX( zzero , SIGN( zone , - zhsnew ) )
+         zhn            =  1.0 - MAX(  zzero , SIGN( zone , - zhsnew )  )
          ht_s_b(ji)     =  MAX( zzero , zhsnew )
          ! Volume and mass variations of snow
-         dvsbq_1d  (ji) =  a_i_b(ji) * ( ht_s_b(ji) - zhsold(ji) - zdh_s_mel(ji) )
+         dvsbq_1d  (ji) =  a_i_b(ji) * ( ht_s_b(ji) - zhsold(ji) - zdh_s_pre(ji) )
          dvsbq_1d  (ji) =  MIN( zzero, dvsbq_1d(ji) )
-         rdmsnif_1d(ji) =  rdmsnif_1d(ji) + rhosn * dvsbq_1d(ji)
+         rdm_snw_1d(ji) =  rdm_snw_1d(ji) + rhosn * dvsbq_1d(ji)
       END DO ! ji
 
@@ -253,5 +255,5 @@
       DO ji = kideb, kiut 
          dh_i_surf(ji) =  0._wp
-         z_f_surf (ji) =  zqfont_su(ji) / rdt_ice ! heat conservation test
+         z_f_surf (ji) =  zqfont_su(ji) * r1_rdtice   ! heat conservation test
          zdq_i    (ji) =  0._wp
       END DO ! ji
@@ -262,17 +264,14 @@
             zdeltah  (ji,jk) = - zqfont_su(ji) / q_i_b(ji,jk)
             !                                                    ! recompute heat available
-            zqfont_su(ji)    = MAX( 0.0 , - zh_i(ji) - zdeltah(ji,jk) ) * q_i_b(ji,jk) 
+            zqfont_su(ji   ) = MAX( 0.0 , - zh_i(ji) - zdeltah(ji,jk) ) * q_i_b(ji,jk) 
             !                                                    ! melt of layer jk cannot be higher than its thickness
             zdeltah  (ji,jk) = MAX( zdeltah(ji,jk) , - zh_i(ji) )
             !                                                    ! update surface melt
-            dh_i_surf(ji)    = dh_i_surf(ji) + zdeltah(ji,jk) 
+            dh_i_surf(ji   ) = dh_i_surf(ji) + zdeltah(ji,jk) 
             !                                                    ! for energy conservation
-            zdq_i    (ji)    = zdq_i(ji) + zdeltah(ji,jk) * q_i_b(ji,jk) / rdt_ice
+            zdq_i    (ji   ) = zdq_i(ji) + zdeltah(ji,jk) * q_i_b(ji,jk) * r1_rdtice
             !
-            ! contribution to ice-ocean salt flux 
-            zji = MOD( npb(ji) - 1 , jpi ) + 1
-            zjj =    ( npb(ji) - 1 ) / jpi + 1
-            zfsalt_melt(ji) = zfsalt_melt(ji) + ( sss_m(zji,zjj) - sm_i_b(ji) ) * a_i_b(ji)    &
-               &                              * MIN( zdeltah(ji,jk) , 0.e0 ) * rhoic / rdt_ice 
+            !                                                    ! contribution to ice-ocean salt flux 
+            zsfx_melt(ji)  = zsfx_melt(ji) - sm_i_b(ji) * a_i_b(ji) * MIN( zdeltah(ji,jk) , 0._wp ) * rhoic * r1_rdtice 
          END DO
       END DO
@@ -290,5 +289,5 @@
             IF( z_f_surf(ji) + zdq_i(ji) .GE. 1.0e-3  ) THEN!
                WRITE(numout,*) ' ALERTE heat loss for surface melt '
-               WRITE(numout,*) ' zji, zjj, jl :', zji, zjj, jl
+               WRITE(numout,*) ' ii, ij, jl :', ii, ij, jl
                WRITE(numout,*) ' ht_i_b       : ', ht_i_b(ji)
                WRITE(numout,*) ' z_f_surf     : ', z_f_surf(ji)
@@ -299,5 +298,5 @@
                WRITE(numout,*) ' qlbbq_1d     : ', qlbbq_1d(ji)
                WRITE(numout,*) ' s_i_new      : ', s_i_new(ji)
-               WRITE(numout,*) ' sss_m        : ', sss_m(zji,zjj)
+               WRITE(numout,*) ' sss_m        : ', sss_m(ii,ij)
             ENDIF
          END DO
@@ -338,5 +337,5 @@
          DO ji = kideb, kiut
             ! In case of disparition of the snow, we have to update the snow temperatures
-            zhisn  =  MAX( zzero , SIGN( zone, - ht_s_b(ji) ) )
+            zhisn  =  MAX(  zzero , SIGN( zone, - ht_s_b(ji) )  )
             t_s_b(ji,jk) = ( 1.0 - zhisn ) * t_s_b(ji,jk) + zhisn * rtt
             q_s_b(ji,jk) = ( 1.0 - zhisn ) * q_s_b(ji,jk)
@@ -358,7 +357,7 @@
       ! 4.1 Basal growth - (a) salinity not varying in time 
       !-----------------------------------------------------
-      IF(  num_sal /= 2  .AND.  num_sal /= 4  ) THEN
-         DO ji = kideb, kiut
-            IF(  ( fc_bo_i(ji) + fbif_1d(ji) + qlbbq_1d(ji) ) < 0.0  ) THEN
+      IF(  num_sal /= 2  ) THEN   ! ice salinity constant in time
+         DO ji = kideb, kiut
+            IF(  ( fc_bo_i(ji) + fbif_1d(ji) + qlbbq_1d(ji) ) < 0._wp  ) THEN
                s_i_new(ji)         =  sm_i_b(ji)
                ! Melting point in K
@@ -371,5 +370,5 @@
                   &                           - rcp  * ( ztmelts - rtt )                                 )
                ! Basal growth rate = - F*dt / q
-               dh_i_bott(ji)       =  - rdt_ice*( fc_bo_i(ji) + fbif_1d(ji) + qlbbq_1d(ji) ) / q_i_b(ji,nlay_i+1) 
+               dh_i_bott(ji)       =  - rdt_ice * ( fc_bo_i(ji) + fbif_1d(ji) + qlbbq_1d(ji) ) / q_i_b(ji,nlay_i+1) 
             ENDIF
          END DO
@@ -379,9 +378,8 @@
       ! 4.1 Basal growth - (b) salinity varying in time 
       !-------------------------------------------------
-      IF(  num_sal == 2 .OR.  num_sal == 4  ) THEN
-         ! the growth rate (dh_i_bott) is function of the new ice
-         ! heat content (q_i_b(nlay_i+1)). q_i_b depends on the new ice 
-         ! salinity (snewice). snewice depends on dh_i_bott
-         ! it converges quickly, so, no problem
+      IF(  num_sal == 2  ) THEN
+         ! the growth rate (dh_i_bott) is function of the new ice heat content (q_i_b(nlay_i+1)). 
+         ! q_i_b depends on the new ice salinity (snewice). 
+         ! snewice depends on dh_i_bott ; it converges quickly, so, no problem
          ! See Vancoppenolle et al., OM08 for more info on this
 
@@ -394,6 +392,6 @@
             DO ji = kideb, kiut
                IF(  fc_bo_i(ji) + fbif_1d(ji) + qlbbq_1d(ji) < 0.e0  ) THEN
-                  zji = MOD( npb(ji) - 1, jpi ) + 1
-                  zjj = ( npb(ji) - 1 ) / jpi + 1
+                  ii = MOD( npb(ji) - 1, jpi ) + 1
+                  ij = ( npb(ji) - 1 ) / jpi + 1
                   ! Melting point in K
                   ztmelts             =   - tmut * s_i_new(ji) + rtt 
@@ -408,5 +406,5 @@
                   ! zswi12 (1) if dh_i_bott/rdt .LT. 3.6e-7 and .GT. 2.0e-8
                   ! zswi1  (1) if dh_i_bott/rdt .LT. 2.0e-8
-                  zgrr   = MIN( 1.0e-3, MAX ( dh_i_bott(ji) / rdt_ice , epsi13 ) )
+                  zgrr   = MIN( 1.0e-3, MAX ( dh_i_bott(ji) * r1_rdtice , epsi13 ) )
                   zswi2  = MAX( zzero , SIGN( zone , zgrr - 3.6e-7 ) ) 
                   zswi12 = MAX( zzero , SIGN( zone , zgrr - 2.0e-8 ) ) * ( 1.0 - zswi2 )
@@ -414,6 +412,6 @@
                   zfracs = zswi1  * 0.12 + zswi12 * ( 0.8925 + 0.0568 * LOG( 100.0 * zgrr ) )   &
                      &                   + zswi2  * 0.26 / ( 0.26 + 0.74 * EXP ( - 724300.0 * zgrr ) ) 
-                  zds         = zfracs * sss_m(zji,zjj) - s_i_new(ji)
-                  s_i_new(ji) = zfracs * sss_m(zji,zjj)
+                  zds         = zfracs * sss_m(ii,ij) - s_i_new(ji)
+                  s_i_new(ji) = zfracs * sss_m(ii,ij)
                ENDIF ! fc_bo_i
             END DO ! ji
@@ -432,5 +430,5 @@
                   &                            - rcp * ( ztmelts - rtt )                                    )
                ! Basal growth rate = - F*dt / q
-               dh_i_bott(ji)       =  - rdt_ice*( fc_bo_i(ji) + fbif_1d(ji) + qlbbq_1d(ji) ) / q_i_b(ji,nlay_i+1) 
+               dh_i_bott(ji)       =  - rdt_ice * ( fc_bo_i(ji) + fbif_1d(ji) + qlbbq_1d(ji) ) / q_i_b(ji,nlay_i+1)
                ! Salinity update
                ! entrapment during bottom growth
@@ -453,5 +451,5 @@
             s_i_new(ji)   =  s_i_b(ji,nlay_i)
             zqfont_bo(ji) =  rdt_ice * ( fc_bo_i(ji) + fbif_1d(ji) + qlbbq_1d(ji) )
-            zfbase(ji)    =  zqfont_bo(ji) / rdt_ice     ! heat conservation test
+            zfbase(ji)    =  zqfont_bo(ji) * r1_rdtice     ! heat conservation test
             zdq_i(ji)     =  0._wp
             dh_i_bott(ji) =  0._wp
@@ -461,22 +459,19 @@
       DO jk = nlay_i, 1, -1
          DO ji = kideb, kiut
-            IF (  ( fc_bo_i(ji) + fbif_1d(ji) + qlbbq_1d(ji) ) .GE. 0.0  ) THEN
-               ztmelts            =   - tmut * s_i_b(ji,jk) + rtt 
-               IF( t_i_b(ji,jk) >= ztmelts ) THEN
-                  zdeltah(ji,jk)  = - zh_i(ji)
-                  dh_i_bott(ji)   = dh_i_bott(ji) + zdeltah(ji,jk)
-                  zinnermelt(ji)   = 1._wp
-               ELSE  ! normal ablation
-                  zdeltah(ji,jk)  = - zqfont_bo(ji) / q_i_b(ji,jk)
-                  zqfont_bo(ji)   = MAX( 0.0 , - zh_i(ji) - zdeltah(ji,jk) ) * q_i_b(ji,jk)
-                  zdeltah(ji,jk)  = MAX(zdeltah(ji,jk), - zh_i(ji) )
-                  dh_i_bott(ji)   = dh_i_bott(ji) + zdeltah(ji,jk)
-                  zdq_i(ji)       = zdq_i(ji) + zdeltah(ji,jk) * q_i_b(ji,jk) / rdt_ice
-                  ! contribution to salt flux
-                  zji             = MOD( npb(ji) - 1, jpi ) + 1
-                  zjj             = ( npb(ji) - 1 ) / jpi + 1
-                  zfsalt_melt(ji) = zfsalt_melt(ji) + ( sss_m(zji,zjj) - sm_i_b(ji)   ) * a_i_b(ji)   &
-                     &                              * MIN( zdeltah(ji,jk) , 0.0 ) * rhoic / rdt_ice 
+            IF(  fc_bo_i(ji) + fbif_1d(ji) + qlbbq_1d(ji)  >=  0._wp  ) THEN
+               ztmelts = - tmut * s_i_b(ji,jk) + rtt 
+               IF( t_i_b(ji,jk) >= ztmelts ) THEN   !!gm : a comment is needed
+                  zdeltah   (ji,jk) = - zh_i(ji)
+                  dh_i_bott (ji   ) = dh_i_bott(ji) + zdeltah(ji,jk)
+                  zinnermelt(ji   ) = 1._wp
+               ELSE                                  ! normal ablation
+                  zdeltah  (ji,jk) = - zqfont_bo(ji) / q_i_b(ji,jk)
+                  zqfont_bo(ji   ) = MAX( 0.0 , - zh_i(ji) - zdeltah(ji,jk) ) * q_i_b(ji,jk)
+                  zdeltah  (ji,jk) = MAX(zdeltah(ji,jk), - zh_i(ji) )
+                  dh_i_bott(ji   ) = dh_i_bott(ji) + zdeltah(ji,jk)
+                  zdq_i    (ji   ) = zdq_i(ji) + zdeltah(ji,jk) * q_i_b(ji,jk) * r1_rdtice
                ENDIF
+               ! contribution to salt flux
+               zsfx_melt(ji) = zsfx_melt(ji) - sm_i_b(ji) * a_i_b(ji) * MIN( zdeltah(ji,jk) , 0._wp ) * rhoic * r1_rdtice 
             ENDIF
          END DO ! ji
@@ -493,5 +488,5 @@
                ENDIF
                IF ( zfbase(ji) + zdq_i(ji) .GE. 1.0e-3  ) THEN
-                  WRITE(numout,*) ' ALERTE heat loss for basal melt : zji, zjj, jl :', zji, zjj, jl
+                  WRITE(numout,*) ' ALERTE heat loss for basal melt : ii, ij, jl :', ii, ij, jl
                   WRITE(numout,*) ' ht_i_b    : ', ht_i_b(ji)
                   WRITE(numout,*) ' zfbase    : ', zfbase(ji)
@@ -502,5 +497,5 @@
                   WRITE(numout,*) ' qlbbq_1d  : ', qlbbq_1d(ji)
                   WRITE(numout,*) ' s_i_new   : ', s_i_new(ji)
-                  WRITE(numout,*) ' sss_m     : ', sss_m(zji,zjj)
+                  WRITE(numout,*) ' sss_m     : ', sss_m(ii,ij)
                   WRITE(numout,*) ' dh_i_bott : ', dh_i_bott(ji)
                   WRITE(numout,*) ' innermelt : ', INT( zinnermelt(ji) )
@@ -531,5 +526,5 @@
          !                     ! excessive energy is sent to lateral ablation
          fsup     (ji) =  rhoic * lfus * at_i_b(ji) / MAX( 1.0 - at_i_b(ji) , epsi13 )   &
-            &                          * ( zdhbf - dh_i_bott(ji) ) / rdt_ice
+            &                          * ( zdhbf - dh_i_bott(ji) ) * r1_rdtice
          dh_i_bott(ji)  = zdhbf
          !                     !since ice volume is only used for outputs, we keep it global for all categories
@@ -538,9 +533,9 @@
          zhgnew   (ji) = ht_i_b(ji) + dh_i_surf(ji) + dh_i_bott(ji)
          !                     ! diagnostic ( bottom ice growth )
-         zji = MOD( npb(ji) - 1, jpi ) + 1
-         zjj = ( npb(ji) - 1 ) / jpi + 1
-         diag_bot_gr(zji,zjj) = diag_bot_gr(zji,zjj) + MAX(dh_i_bott(ji),0.0)*a_i_b(ji) / rdt_ice
-         diag_sur_me(zji,zjj) = diag_sur_me(zji,zjj) + MIN(dh_i_surf(ji),0.0)*a_i_b(ji) / rdt_ice
-         diag_bot_me(zji,zjj) = diag_bot_me(zji,zjj) + MIN(dh_i_bott(ji),0.0)*a_i_b(ji) / rdt_ice
+         ii = MOD( npb(ji) - 1, jpi ) + 1
+         ij = ( npb(ji) - 1 ) / jpi + 1
+         diag_bot_gr(ii,ij) = diag_bot_gr(ii,ij) + MAX(dh_i_bott(ji),0.0)*a_i_b(ji) * r1_rdtice
+         diag_sur_me(ii,ij) = diag_sur_me(ii,ij) + MIN(dh_i_surf(ji),0.0)*a_i_b(ji) * r1_rdtice
+         diag_bot_me(ii,ij) = diag_bot_me(ii,ij) + MIN(dh_i_bott(ji),0.0)*a_i_b(ji) * r1_rdtice
       END DO
 
@@ -548,11 +543,10 @@
       ! 5.2 More than available ice melts
       !-----------------------------------
-      ! then heat applied minus heat content at previous time step
-      ! should equal heat remaining 
+      ! then heat applied minus heat content at previous time step should equal heat remaining 
       !
       DO ji = kideb, kiut
          ! Adapt the remaining energy if too much ice melts
          !--------------------------------------------------
-         zihgnew    =  1.0 - MAX( zzero , SIGN( zone , - zhgnew(ji) ) ) !1 if ice
+         zihgnew =  1.0 - MAX( zzero , SIGN( zone , - zhgnew(ji) ) )   ! =1 if ice
          ! 0 if no more ice
          zhgnew    (ji) =         zihgnew   * zhgnew(ji)      ! ice thickness is put to 0
@@ -562,10 +556,10 @@
          ! If snow remains, energy is used to melt snow
          zhni =  ht_s_b(ji)      ! snow depth at previous time step
-         zihg =  MAX( zzero , SIGN ( zone , - ht_s_b(ji) ) ) ! 0 if snow 
+         zihg =  MAX(  zzero , SIGN ( zone , - ht_s_b(ji) )  )   ! =0 if snow 
 
          ! energy of melting of remaining snow
          zqt_s(ji) =    ( 1. - zihg ) * zqt_s(ji) / MAX( zhni, epsi13 )
          zdhnm     =  - ( 1. - zihg ) * ( 1. - zihgnew ) * zfdt_final(ji) / MAX( zqt_s(ji) , epsi13 )
-         zhnfi          =  zhni + zdhnm
+         zhnfi     =  zhni + zdhnm
          zfdt_final(ji) =  MAX( zfdt_final(ji) + zqt_s(ji) * zdhnm , 0.0 )
          ht_s_b(ji)     =  MAX( zzero , zhnfi )
@@ -581,14 +575,14 @@
          !
          !                                              ! mass variation cumulated over category
-         rdmsnif_1d(ji) = rdmsnif_1d(ji) + zzfmass_s                     ! snow 
-         rdmicif_1d(ji) = rdmicif_1d(ji) + zzfmass_i                     ! ice 
+         rdm_snw_1d(ji) = rdm_snw_1d(ji) + zzfmass_s                     ! snow 
+         rdm_ice_1d(ji) = rdm_ice_1d(ji) + zzfmass_i                     ! ice 
 
          ! Remaining heat to the ocean 
          !---------------------------------
-         focea(ji)  = - zfdt_final(ji) / rdt_ice         ! focea is in W.m-2 * dt
-
-      END DO
-
-      ftotal_fin (:) = zfdt_final(:)  / rdt_ice
+         focea(ji)  = - zfdt_final(ji) * r1_rdtice         ! focea is in W.m-2 * dt
+
+      END DO
+
+      ftotal_fin (:) = zfdt_final(:)  * r1_rdtice
 
       !---------------------------
@@ -596,26 +590,18 @@
       !---------------------------
       DO ji = kideb, kiut
-         zihgnew    =  1.0 - MAX( zzero , SIGN( zone , - zhgnew(ji) ) )   !1 if ice
-
+         zihgnew    =  1.0 - MAX( zzero , SIGN( zone , - zhgnew(ji) ) )   ! =1 if ice
+         !
          ! Salt flux
-         zji = MOD( npb(ji) - 1, jpi ) + 1
-         zjj = ( npb(ji) - 1 ) / jpi + 1
-         ! new lines
-         IF( num_sal == 4 ) THEN
-            fseqv_1d(ji) = fseqv_1d(ji) +        zihgnew  * zfsalt_melt(ji)                                &
-               &                        + (1.0 - zihgnew) * zfmass_i(ji) * ( sss_m(zji,zjj) - bulk_sal   ) / rdt_ice
-         ELSE
-            fseqv_1d(ji) = fseqv_1d(ji) +        zihgnew  * zfsalt_melt(ji)                                &
-               &                        + (1.0 - zihgnew) * zfmass_i(ji) * ( sss_m(zji,zjj) - sm_i_b(ji) ) / rdt_ice
-         ENDIF
+         sfx_thd_1d(ji) = sfx_thd_1d(ji) +        zihgnew  * zsfx_melt(ji)               &
+            &                            - (1.0 - zihgnew) * zfmass_i (ji) * sm_i_b(ji)  * r1_rdtice
+         !
          ! Heat flux
          ! excessive bottom ablation energy (fsup) - 0 except if jpl = 1
-         ! excessive total ablation energy (focea) sent to the ocean
+         ! excessive total  ablation energy (focea) sent to the ocean
          qfvbq_1d(ji)  = qfvbq_1d(ji) + fsup(ji) + ( 1.0 - zihgnew ) * focea(ji) * a_i_b(ji) * rdt_ice
 
-         zihic   = 1.0 - MAX( zzero , SIGN( zone , -ht_i_b(ji) ) )
-         ! equals 0 if ht_i = 0, 1 if ht_i gt 0
+         zihic   = 1.0 - MAX(  zzero , SIGN( zone , -ht_i_b(ji) )  )      ! equals 0 if ht_i = 0, 1 if ht_i gt 0
          fscbq_1d(ji) =  a_i_b(ji) * fstbif_1d(ji)
-         qldif_1d(ji)  = qldif_1d(ji) + fsup(ji) + ( 1.0 - zihgnew ) * focea(ji)    * a_i_b(ji) * rdt_ice   &
+         qldif_1d(ji)  = qldif_1d(ji) + fsup(ji) + ( 1.0 - zihgnew ) * focea   (ji) * a_i_b(ji) * rdt_ice   &
             &                                    + ( 1.0 - zihic   ) * fscbq_1d(ji)             * rdt_ice
       END DO  ! ji
@@ -656,29 +642,25 @@
          dmgwi_1d  (ji) = dmgwi_1d(ji) + a_i_b(ji) * ( ht_s_b(ji) - zhnnew ) * rhosn
 
-         rdmicif_1d(ji) = rdmicif_1d(ji) + a_i_b(ji) * ( zhgnew(ji) - ht_i_b(ji) ) * rhoic 
-         rdmsnif_1d(ji) = rdmsnif_1d(ji) + a_i_b(ji) * ( zhnnew     - ht_s_b(ji) ) * rhosn
+         ! All snow is thrown in the ocean, and seawater is taken to replace the volume
+         rdm_ice_1d(ji) = rdm_ice_1d(ji) + a_i_b(ji) * ( zhgnew(ji) - ht_i_b(ji) ) * rhoic * ( 1. - rhosn / rhoic )
+         rdm_snw_1d(ji) = rdm_snw_1d(ji) + a_i_b(ji) * ( zhnnew     - ht_s_b(ji) ) * rhosn
 
          !        Equivalent salt flux (1) Snow-ice formation component
          !        -----------------------------------------------------
-         zji = MOD( npb(ji) - 1, jpi ) + 1
-         zjj =    ( npb(ji) - 1 ) / jpi + 1
-
-         IF( num_sal /= 2 ) THEN   ;   zsm_snowice = sm_i_b(ji)
-         ELSE                      ;   zsm_snowice = ( rhoic - rhosn ) / rhoic * sss_m(zji,zjj) 
+         ii = MOD( npb(ji) - 1, jpi ) + 1
+         ij =    ( npb(ji) - 1 ) / jpi + 1
+
+         IF( num_sal == 2 ) THEN   ;   zsm_snowice = sss_m(ii,ij) * ( rhoic - rhosn ) / rhoic
+         ELSE                      ;   zsm_snowice = sm_i_b(ji)   
          ENDIF
-         IF( num_sal == 4 ) THEN
-            fseqv_1d(ji) = fseqv_1d(ji) + ( sss_m(zji,zjj) - bulk_sal    ) * a_i_b(ji)   &
-               &                        * ( zhgnew(ji) - ht_i_b(ji) ) * rhoic / rdt_ice
-         ELSE
-            fseqv_1d(ji) = fseqv_1d(ji) + ( sss_m(zji,zjj) - zsm_snowice ) * a_i_b(ji)   &
-               &                        * ( zhgnew(ji) - ht_i_b(ji) ) * rhoic / rdt_ice
-         ENDIF
+         sfx_thd_1d(ji) = sfx_thd_1d(ji) - zsm_snowice * a_i_b(ji) * dh_snowice(ji) * rhoic * r1_rdtice
+         !
          ! entrapment during snow ice formation
          i_ice_switch = 1.0 - MAX( 0.e0 , SIGN( 1.0 , - ht_i_b(ji) + 1.0e-6 ) )
          isnowic      = 1.0 - MAX( 0.e0 , SIGN( 1.0 , - dh_snowice(ji)      ) ) * i_ice_switch
-         IF(  num_sal == 2  .OR.  num_sal == 4  )   &
-            dsm_i_si_1d(ji) = ( zsm_snowice*dh_snowice(ji) &
-            &               + sm_i_b(ji) * ht_i_b(ji) / MAX( ht_i_b(ji) + dh_snowice(ji), epsi13)   &
-            &               - sm_i_b(ji) ) * isnowic     
+         IF(  num_sal == 2  )   &
+            dsm_i_si_1d(ji) = (  zsm_snowice * dh_snowice(ji)    &
+            &                  + sm_i_b(ji) * ht_i_b(ji) / MAX( ht_i_b(ji) + dh_snowice(ji), epsi13 )   &
+            &                  - sm_i_b(ji)  ) * isnowic     
 
          !  Actualize new snow and ice thickness.
@@ -690,12 +672,12 @@
 
          ! diagnostic ( snow ice growth )
-         zji = MOD( npb(ji) - 1, jpi ) + 1
-         zjj =    ( npb(ji) - 1 ) / jpi + 1
-         diag_sni_gr(zji,zjj)  = diag_sni_gr(zji,zjj) + dh_snowice(ji)*a_i_b(ji) / rdt_ice
+         ii = MOD( npb(ji) - 1, jpi ) + 1
+         ij =    ( npb(ji) - 1 ) / jpi + 1
+         diag_sni_gr(ii,ij)  = diag_sni_gr(ii,ij) + dh_snowice(ji)*a_i_b(ji) * r1_rdtice
          !
       END DO !ji
       !
       CALL wrk_dealloc( jpij, zh_i, zh_s, ztfs, zhsold, zqprec, zqfont_su, zqfont_bo, z_f_surf, zhgnew, zfmass_i )
-      CALL wrk_dealloc( jpij, zdh_s_mel, zdh_s_pre, zdh_s_sub, zfsalt_melt, zfdt_init, zfdt_final, zqt_i, zqt_s, zqt_dummy )
+      CALL wrk_dealloc( jpij, zdh_s_mel, zdh_s_pre, zdh_s_sub, zsfx_melt, zfdt_init, zfdt_final, zqt_i, zqt_s, zqt_dummy )
       CALL wrk_dealloc( jpij, zinnermelt, zfbase, zdq_i )
       CALL wrk_dealloc( jpij, jkmax, zdeltah, zqt_i_lay )
Index: branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/LIM_SRC_3/limthd_dif.F90
===================================================================
--- branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/LIM_SRC_3/limthd_dif.F90	(revision 3614)
+++ branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/LIM_SRC_3/limthd_dif.F90	(revision 3625)
@@ -15,12 +15,13 @@
    !!   'key_lim3'                                      LIM3 sea-ice model
    !!----------------------------------------------------------------------
-   USE par_oce          ! ocean parameters
-   USE phycst           ! physical constants (ocean directory) 
-   USE ice              ! LIM-3 variables
-   USE par_ice          ! LIM-3 parameters
-   USE thd_ice          ! LIM-3: thermodynamics
-   USE in_out_manager   ! I/O manager
-   USE lib_mpp          ! MPP library
-   USE wrk_nemo         ! work arrays
+   USE par_oce        ! ocean parameters
+   USE phycst         ! physical constants (ocean directory) 
+   USE ice            ! LIM-3 variables
+   USE par_ice        ! LIM-3 parameters
+   USE thd_ice        ! LIM-3: thermodynamics
+   USE in_out_manager ! I/O manager
+   USE lib_mpp        ! MPP library
+   USE wrk_nemo       ! work arrays
+   USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
 
    IMPLICIT NONE
@@ -33,5 +34,5 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2011)
+   !! NEMO/LIM3 3.4 , UCL - NEMO Consortium (2011)
    !! $Id$
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -147,6 +148,5 @@
       REAL(wp), DIMENSION(kiut,jkmax+2) ::   zdiagbis
       REAL(wp), DIMENSION(kiut,jkmax+2,3) ::   ztrid   ! tridiagonal system terms
-      !!------------------------------------------------------------------
-      
+      !!------------------------------------------------------------------     
       ! 
       !------------------------------------------------------------------------------!
@@ -156,5 +156,5 @@
       DO ji = kideb , kiut
          ! is there snow or not
-         isnow(ji)= INT(  1._wp - MAX( 0._wp , SIGN(1._wp, - ht_s_b(ji) ) )  )
+         isnow(ji)= INT(  1._wp - MAX(  0._wp , SIGN(1._wp, - ht_s_b(ji) )  )  )
          ! surface temperature of fusion
 !!gm ???  ztfs(ji) = rtt !!!????
@@ -201,5 +201,5 @@
       DO ji = kideb , kiut
          ! switches
-         isnow(ji) = INT(  1._wp - MAX( 0._wp , SIGN( 1._wp , - ht_s_b(ji) ) )  ) 
+         isnow(ji) = INT(  1._wp - MAX(  0._wp , SIGN( 1._wp , - ht_s_b(ji) )  )  ) 
          ! hs > 0, isnow = 1
          zhsu (ji) = hnzst  ! threshold for the computation of i0
@@ -262,6 +262,6 @@
       ! just to check energy conservation
       DO ji = kideb, kiut
-         ii                = MOD( npb(ji) - 1, jpi ) + 1
-         ij                = ( npb(ji) - 1 ) / jpi + 1
+         ii = MOD( npb(ji) - 1 , jpi ) + 1
+         ij =    ( npb(ji) - 1 ) / jpi + 1
          fstroc(ii,ij,jl) = zradtr_i(ji,nlay_i)
       END DO
@@ -273,5 +273,4 @@
          END DO
       END DO
-
 
       !
@@ -662,7 +661,7 @@
 
             ! surface temperature
-            isnow(ji)     = INT(1.0-max(0.0,sign(1.0,-ht_s_b(ji))))
+            isnow(ji)     = INT(  1.0 - MAX( 0.0 , SIGN( 1.0 , -ht_s_b(ji) )  )  )
             ztsuoldit(ji) = t_su_b(ji)
-            IF (t_su_b(ji) .LT. ztfs(ji)) &
+            IF( t_su_b(ji) < ztfs(ji) )   &
                t_su_b(ji) = ( zindtbis(ji,numeqmin(ji)) - ztrid(ji,numeqmin(ji),3)* ( isnow(ji)*t_s_b(ji,1)   &
                &          + (1.0-isnow(ji))*t_i_b(ji,1) ) ) / zdiagbis(ji,numeqmin(ji))  
